import bham.leakwatch.LeakWatchAPI;
import java.security.SecureRandom;

public class GuessPresenceAll {

  // N is the total number of houses 
  static int N=3;

  // We consider different sizes of houses. S, M and L indicate the number of houses of each size.
  static int S=N/3 ;
  static int M=N/3 ;
  static int L=N-S-M ;

  // each size correspond to a different level of consumption
  static int  small_consumption = 1 ;
  static int medium_consumption = 3 ;
  static int  large_consumption = 5 ;

  // the observable is the global consumption of the system
  static int global_consumption =0 ;

  // The secret is the presence of people in each hose
  static  int[] presence;

  static void initPublicValues(String[] args) {
    if (args.length < 1) {
      System.out.println("Usage: GuessPresenceAll <nb_houses> [case1|case2]");
      System.exit(1);
    }
    N=Integer.parseInt(args[0]);
    S=N/3 ;
    M=N/3 ;
    L=N-S-M ;

    if (args.length > 1) {
      if (args[1].equals("case1")) {
	small_consumption = 1 ;
	medium_consumption = 2 ;
	large_consumption = 3 ;
      }
      else {
	small_consumption = 1 ;
	medium_consumption = 3 ;
	large_consumption = 5 ;
      }
    }
  }


  static void initPrivateValues() {
    SecureRandom rand = new SecureRandom(); 
    // secret var is used to sumarize the table in an int
    int secret_var = 0;

    presence = new int[N];
    for(int i =0; i<N ; i++){
      presence[i]=rand.nextInt(2);
      secret_var=2*secret_var + presence[i];
    }
    LeakWatchAPI.secret("secret_var",secret_var);
  }


  public static void main(String[] args){
    initPublicValues(args);
    // init private values in the intervals defined in QUAIL file
    initPrivateValues();

    int i  = 0;
    while ( i < N) {
      if (presence[i] == 1) {
	if (i<S) {
	  global_consumption = global_consumption + small_consumption ;
	}
	else if (i<S+M) {
	  global_consumption = global_consumption + medium_consumption ;
	}
	else{
	  global_consumption = global_consumption + large_consumption ;
	}
      }
      i= i + 1;
    }
    LeakWatchAPI.observe(global_consumption);
  }

}
