import bham.leakwatch.LeakWatchAPI;
import java.security.SecureRandom;

public class PreferenceRanking {
  // N is the number of voters
  public static int N=3;

  // C is the number of candidates
  public static int C=3;
  // the result is the number of votes of each candidate
  static int[] result;

  // The secret is the preference of each voter
  static int[] vote;


  //temporary tables used by the QUAIL version
  static int[] decl;
  static int[] temparray;

  //factorial function
  static int fact(int n){
    if (n <= 1) 
      return 1;
    else
      return n*fact(n-1);
  }

  static void initPublicValues(String[] args) {
    if (args.length < 2) {
      System.out.println("Usage: PreferenceRanking <nb_voters> <nb_candidates>");
      System.exit(1);
    }
    N=Integer.parseInt(args[0]);
    C=Integer.parseInt(args[1]);

    result = new int[C];
    for (int i=0 ; i<C ; i++) result[i] = 0;
  }

  static void initPrivateValues() {
    SecureRandom rand = new SecureRandom(); 

    vote = new int[N];
    int CFACT= fact(C);
    for(int i =0; i<N ; i++){
      vote[i]=rand.nextInt(CFACT);
      LeakWatchAPI.secret("vote[i]",vote[i]);
    }
  }

  public static void main(String[] args){
    initPublicValues(args);
    // init private values in the intervals defined in QUAIL file
    initPrivateValues();

    int voter = 0;
    int vote_val = 0;
    decl=new int[N];
    // voting
    while (voter<N) {
      while (vote_val<fact(C)) {
	if (vote[voter]==vote_val) {
	  decl[voter]=vote_val;
	}  
	vote_val=vote_val+1;
      }
      vote_val=0;
      voter=voter+1;
    }

    // transform the secret of each voter into the order of the preferences
    voter=0;
    while (voter<N) { 

      // build the initial array
      int candidate=0;
      temparray = new int[C];
      while (candidate<C){
	temparray[candidate]=candidate;
	candidate=candidate+1;
      }

      int k=C;
      // find a position
      while (k>0) {
	int pos = decl[voter]%k;
	candidate=C-k;
	// update the vote of the candidate
	result[candidate]=result[candidate]+temparray[pos];

	// remove the element from the array
	int y=pos;
	while (y<C-1) {
	  temparray[y]=temparray[y+1];
	  y=y+1;
	}

	// update the vote of the voter
	decl[voter]=decl[voter]/k;

	// decrease the counter
	k=k-1;
      }
      voter=voter+1;
    }
    for (int j=0; j<C ; j++){
      LeakWatchAPI.observe(result[j]);
    }
  }
}
