import bham.leakwatch.LeakWatchAPI;
import java.security.SecureRandom;

public class SinglePreference {
  // N is the number of voters
  public static int N;

  // C is the number of candidates
  public static int C;
  // the result is the number of votes of each candidate
  static int[] result;

  // The secret is the preference of each voter
  static int[] vote;


  static void initPublicValues(String[] args) {
    if (args.length < 2) {
      System.out.println("Usage: SinglePreference <nb_voters> <nb_candidates>");
      System.exit(1);
    }
    N=Integer.parseInt(args[0]);
    C=Integer.parseInt(args[1]);

    result = new int[C];
    for (int i=0 ; i<C ; i++) result[i] = 0;
  }

  static void initPrivateValues() {
    SecureRandom rand = new SecureRandom(); 

    vote = new int[N];
    for(int i =0; i<N ; i++){
      vote[i]=rand.nextInt(C);
      LeakWatchAPI.secret("voute[i]",vote[i]);
    }
  }

  public static void main(String[] args){
    initPublicValues(args);
    // init private values in the intervals defined in QUAIL file
    initPrivateValues();

    int i = 0;
    int j  = 0;
    while (i < N) {
      j=0;
      while (j < C) {
	if (vote[i] == j) {
	  result[j] = result[j] + 1 ;
	}
	j= j+1;
      }
      i= i + 1;
    }
    for(j=0; j<C ; j++) LeakWatchAPI.observe(result[j]);
  }
}
